TimeBucketCounter (Apache Tomcat 10.1.39 API Documentation)
Description: declaration: package: org.apache.catalina.util, class: TimeBucketCounter

# Class TimeBucketCounter

java.lang.Object
org.apache.catalina.util.TimeBucketCounter

public class TimeBucketCounter extends Object
This class maintains a thread safe hash map that has timestamp-based buckets followed by a string for a key, and a counter for a value. each time the increment() method is called it adds the key if it does not exist, increments its value and returns it. a maintenance thread cleans up keys that are prefixed by previous timestamp buckets.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TimeBucketCounter(int bucketDuration, ScheduledExecutorService executorService)`
  Creates a new TimeBucketCounter with the specified lifetime.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `destroy()`
  Sets isRunning to false to terminate the maintenance thread.
  `int`
  `getActualDuration()`
  The actual duration may differ from the configured duration because it is set to the next power of 2 value in order to perform very fast bit shift arithmetic.
  `final int`
  `getCurrentBucketPrefix()`
  Calculates the current time bucket prefix by shifting bits for fast division, e.g. shift 16 bits is the same as dividing by 65,536 which is about 1:05m.
  `long`
  `getMillisUntilNextBucket()`
  When we want to test a full bucket duration we need to sleep until the next bucket starts.
  `int`
  `getNumBits()`
  `double`
  `getRatio()`
  Returns the ratio between the configured duration param and the actual duration which will be set to the next power of 2.
  `final int`
  `increment(String identifier)`
  Increments the counter for the passed identifier in the current time bucket and returns the new value.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TimeBucketCounter

    public TimeBucketCounter(int bucketDuration, ScheduledExecutorService executorService)
    Creates a new TimeBucketCounter with the specified lifetime.
    Parameters:
      `bucketDuration` - duration in seconds, e.g. for 1 minute pass 60
      `executorService` - the executor service which will be used to run the maintenance

- ## Method Details

  - ### increment

    public final int increment(String identifier)
    Increments the counter for the passed identifier in the current time bucket and returns the new value.
    Parameters:
      `identifier` - an identifier for which we want to maintain count, e.g. IP Address
    Returns:
      the count within the current time bucket

  - ### getCurrentBucketPrefix

    public final int getCurrentBucketPrefix()
    Calculates the current time bucket prefix by shifting bits for fast division, e.g. shift 16 bits is the same as dividing by 65,536 which is about 1:05m.
    Returns:
      The current bucket prefix.

  - ### getNumBits

    public int getNumBits()

  - ### getActualDuration

    public int getActualDuration()
    The actual duration may differ from the configured duration because it is set to the next power of 2 value in order to perform very fast bit shift arithmetic.
    Returns:
      the actual bucket duration in milliseconds

  - ### getRatio

    public double getRatio()
    Returns the ratio between the configured duration param and the actual duration which will be set to the next power of 2. We then multiply the configured requests param by the same ratio in order to compensate for the added time, if any.
    Returns:
      the ratio, e.g. 1.092 if the actual duration is 65_536 for the configured duration of 60_000

  - ### getMillisUntilNextBucket

    public long getMillisUntilNextBucket()
    When we want to test a full bucket duration we need to sleep until the next bucket starts.
    Returns:
      the number of milliseconds until the next bucket

  - ### destroy

    public void destroy()
    Sets isRunning to false to terminate the maintenance thread.